#include"robo.h"
#include<bits/stdc++.h>
using namespace std;

int n, m;
int dow[202][202], up[202][202], le[202][202], ri[202][202];
int t[404][404], br1=0;
int t2[404][404], br2=0;
int s[202][202];

void scanrob(int i, int j, int dist)
{
    br1++;
    t[i][j]=1;
    if(!t[i-1][j])
    {
        int ndist=output(1, 'U');
        if(ndist!=dist)
        {
            scanrob(i-1, j, ndist);
            output(1, 'D');
        }
    }
    if(!t[i+1][j])
    {
        int ndist=output(1, 'D');
        if(ndist!=dist)
        {
            scanrob(i+1, j, ndist);
            output(1, 'U');
        }
    }
    if(!t[i][j-1])
    {
        int ndist=output(1, 'L');
        if(ndist!=dist)
        {
            scanrob(i, j-1, ndist);
            output(1, 'R');
        }
    }
    if(!t[i][j+1])
    {
        int ndist=output(1, 'R');
        if(ndist!=dist)
        {
            scanrob(i, j+1, ndist);
            output(1, 'L');
        }
    }
}

void scan2rob(int i, int j, int dist)
{
    br2++;
    t2[i][j]=1;
    if(!t2[i-1][j])
    {
        int ndist=output(2, 'U');
        if(ndist!=dist)
        {
            scan2rob(i-1, j, ndist);
            output(2, 'D');
        }
    }
    if(!t2[i+1][j])
    {
        int ndist=output(2, 'D');
        if(ndist!=dist)
        {
            scan2rob(i+1, j, ndist);
            output(2, 'U');
        }
    }
    if(!t2[i][j-1])
    {
        int ndist=output(2, 'L');
        if(ndist!=dist)
        {
            scan2rob(i, j-1, ndist);
            output(2, 'R');
        }
    }
    if(!t2[i][j+1])
    {
        int ndist=output(2, 'R');
        if(ndist!=dist)
        {
            scan2rob(i, j+1, ndist);
            output(2, 'L');
        }
    }
}

bool provotkl(int di, int dj, int& ki2, int &kj2)
{
    bool fl=0;
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            if(s[i][j]==t[200-di+i][200-dj+j]) continue;
            if(fl) return 0;
            fl=1;
            ki2=i;
            kj2=j;
        }
    }
    return 1;
}

int fi1=-1, fj1, fi2, fj2;

char par[202][202];

void findpar(int i, int j)
{
    if(i && s[i-1][j] && !par[i-1][j])
    {
        par[i-1][j]='D';
        findpar(i-1, j);
    }
    if(i<n-1 && s[i+1][j] && !par[i+1][j])
    {
        par[i+1][j]='U';
        findpar(i+1, j);
    }
    if(j && s[i][j-1] && !par[i][j-1])
    {
        par[i][j-1]='R';
        findpar(i, j-1);
    }
    if(j<m-1 && s[i][j+1] && !par[i][j+1])
    {
        par[i][j+1]='L';
        findpar(i, j+1);
    }
}

bool smqna=0;
string s1;

void robo(int R, int C, char store[][201], int dist)
{
    int brpr=0;
    n=R, m=C;
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            if(store[i][j]!='#')
            {
                s[i][j]=1;
                brpr++;
                up[i][j]=1;
                le[i][j]=1;
                if(i) up[i][j]+=up[i-1][j];
                if(j) le[i][j]+=le[i][j-1];
            }
            else s[i][j]=0;
            if(store[i][j]=='P')
            {
                if(fi1==-1) fi1=i, fj1=j;
                else fi2=i, fj2=j;
            }
        }
    }
    for(int i=n-1; i>=0; i--)
    {
        for(int j=m-1; j>=0; j--)
        {
            if(store[i][j]!='#')
            {
                dow[i][j]=1;
                ri[i][j]=1;
                if(i!=n-1) dow[i][j]+=dow[i+1][j];
                if(j!=m-1) ri[i][j]+=ri[i][j+1];
            }
        }
    }
    scanrob(200, 200, dist);
    if(brpr%2 && brpr-1!=br1)
    {
        scan2rob(200, 200, dist);
    }
    else
    {
        bool fl5=0;
        int ki1=0, kj1=0, ki2=0, kj2=0;
        for(int i=0; i<n; i++)
        {
            for(int j=0; j<m; j++)
            {
                if(provotkl(i, j, ki2, kj2))
                {
                    ki1=i;
                    kj1=j;
                    fl5=1;
                    break;
                }
            }
            if(fl5) break;
        }
        memset(par, 0, sizeof(par));
        findpar(ki1, kj1);


        int pi1=fi1, pj1=fj1;
        s1="";
        while(pi1!=ki1 || pj1!=kj1)
        {
            char c=par[pi1][pj1];
            if(c=='U')
            {
                c='D';
                pi1--;
            }
            else if(c=='D')
            {
                c='U';
                pi1++;
            }
            else if(c=='L')
            {
                c='R';
                pj1--;
            }
            else if(c=='R')
            {
                c='L';
                pj1++;
            }
            s1=c+s1;
        }
        for(int i=0; i<s1.size(); i++) output(1, s1[i]);
        memset(par, 0, sizeof(par));
        findpar(ki2, kj2);
        int pi2=fi2, pj2=fj2;
        s1="";
        while(pi2!=ki2 || pj2!=kj2)
        {
            char c=par[pi2][pj2];
            if(c=='U')
            {
                c='D';
                pi2--;
            }
            else if(c=='D')
            {
                c='U';
                pi2++;
            }
            else if(c=='L')
            {
                c='R';
                pj2--;
            }
            else if(c=='R')
            {
                c='L';
                pj2++;
            }
            s1=c+s1;
        }
        for(int i=0; i<s1.size(); i++) {output(2, s1[i]);}

    }
}
