#include <iostream>
#define int long long
using namespace std;
const int maxn = 1e6+10, maxk = 12, inf = 1e15;

int dp[2][maxk][2];
int a[maxn], n, k;

void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

}

void read() {

    cin >> n >> k;

    for (int i = 1 ; i <= n ; ++i)
        cin >> a[i];

}

void solve() {

    dp[(n+1)&1][k+1][0] = -inf;
    dp[(n+1)&1][k+1][1] = -inf;
    for (int i = 0 ; i <= k ; ++i) {
        dp[(n+1)&1][i][1] = -inf; 
        dp[(n+1)&1][i][0] = 0; 
    }

    for (int ix = n ; ix > 0 ; --ix) {
        for (int cycle = k ; cycle >= 0 ; --cycle) {
            for (int started = 0 ; started < 2 ; ++started) {
                dp[ix&1][cycle][started] = max(dp[(ix+1)&1][cycle][started], dp[(ix+1)&1][cycle + (!started)][!started] + (started ? a[ix] : -a[ix]));
            }
        }
    }

    cout << dp[1][0][0] << '\n';

}

signed main () {

    fast_io();
    read();
    solve();
    return 0;

}