#include<bits/stdc++.h>
#pragma GCC optimize ("O3")
using namespace std;

const int maxn = 1000001;
int n, k, a[maxn], p[maxn],  max_ans;

struct ver
{
    int min1;
    int max1;
};

ver t[4*maxn];

void make_tree(int i, int l, int r)
{
    if (l == r)
        t[i].min1 = t[i].max1 = a[l];
    else
    {
        int m = (l+r)/2;
        make_tree(2*i, l, m);
        make_tree(2*i+1, m+1, r);
        /*t[i].min1 = t[2*i].min1 < t[2*i+1].min1 ? t[2*i].min1 : t[2*i+1].min1;
        t[i].max1 = t[2*i].max1 > t[2*i+1].max1 ? t[2*i].max1 : t[2*i+1].max1;*/
        t[i] = {min(t[2*i].min1,t[2*i+1].min1), max(t[2*i].max1,t[2*i+1].max1)};
    }
}

ver query(int i, int l, int r, int ql, int qr)
{
    if (l==ql && r==qr)
        return t[i];
    int m = (l+r)/2;
    if (ql > m)
        return query(2*i+1, m+1, r, ql, qr);
    else if (qr <= m)
        return query(2*i, l, m, ql, qr);
    else
    {
        ver p1 = query(2*i, l, m, ql, m);
        ver p2 = query(2*i+1, m+1, r, m+1, qr);
        /*ver q;
        q.min1 = p1.min1 < p2.min1 ? p1.min1 : p2.min1;
        q.max1 = p1.max1 > p2.max1 ? p1.max1 : p2.max1;*/
        return {min(p1.min1,p2.min1), max(p1.max1,p2.max1)};
    }
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> k ;
    int i;
    for (i=1; i<=n; ++i)
    {
        cin >> a[i] ;
    }
    make_tree(1, 1, n);
}

/*void solve()
{
    int ans = 0, i;
    ver h;
    p[k] = n;
    for (i=1; i<=k; ++i)
    {
        h = query(1, 1, n, p[i-1]+1, p[i]);
        ans += (h.max1-h.min1);
    }
    if (ans > max_ans)
        max_ans = ans;
}*/

void v(int pos, int last_i)
{
    if (pos == k)
    {
        //solve();
        int ans = 0, i;
        ver h;
        p[k] = n;
        for (i=1; i<=k; ++i)
        {
            h = query(1, 1, n, p[i-1]+1, p[i]);
            ans += (h.max1-h.min1);
        }
        if (ans > max_ans)
            max_ans = ans;
        return;
    }
    for (int i=last_i+2; i<n-1; ++i)
    {
        p[pos] = i;
        v(pos+1, i);
    }
}

int main()
{
    read();
    v(1,0);
    cout << max_ans << '\n';
    return 0;
}