#include <iostream>
#define int long long
using namespace std;
const int maxn = 1e5, maxk = 11, inf = 1e15;

int dp[maxn][maxk][2];
bool bl[maxn][maxk][2];
int a[maxn], n, k;

int f(int ix, int cycle, bool started) {

    if (cycle > k) return -inf;
    if (ix > n) return (started == 0 ? 0 : -inf);
    if (bl[ix][cycle][started]) return dp[ix][cycle][started];
    bl[ix][cycle][started] = 1;
    dp[ix][cycle][started] = f(ix+1, cycle, started);

    dp[ix][cycle][started] = max(dp[ix][cycle][started], f(ix+1, cycle + (!started), !started) + (started ? a[ix] : -a[ix]));

    if (dp[ix][cycle][started] < -inf) dp[ix][cycle][started] = -inf;

    return dp[ix][cycle][started];

}

void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

}

void read() {

    cin >> n >> k;

    for (int i = 1 ; i <= n ; ++i)
        cin >> a[i];

}

void solve() {

    cout << f(1, 0, 0) << '\n';

}

signed main () {

    fast_io();
    read();
    solve();
    return 0;

}