#include<bits/stdc++.h>
#pragma GCC optimize ("O3")
using namespace std;

const long long maxn = 1000001;
long long n, k, a[maxn], p[maxn],  max_ans;

struct ver
{
    long long min1;
    long long max1;
};

ver t[4*maxn];

void make_tree(long long i, long long l, long long r)
{
    if (l == r) t[i].min1 = t[i].max1 = a[l];
    else
    {
        long long m = (l+r)/2;
        make_tree(2*i, l, m);
        make_tree(2*i+1, m+1, r);
        /*t[i].min1 = t[2*i].min1 < t[2*i+1].min1 ? t[2*i].min1 : t[2*i+1].min1;
        t[i].max1 = t[2*i].max1 > t[2*i+1].max1 ? t[2*i].max1 : t[2*i+1].max1;*/
        t[i] = {min(t[2*i].min1,t[2*i+1].min1) , max(t[2*i].max1,t[2*i+1].max1)};
    }
}

ver query(long long i, long long l, long long r, long long ql, long long qr)
{
    if (l==ql && r==qr) return t[i];
    long long m = (l+r)/2;
    if (ql > m) return query(2*i+1, m+1, r, ql, qr);
    else if (qr <= m) return query(2*i, l, m, ql, qr);
    else
    {
        ver p1 = query(2*i, l, m, ql, m);
        ver p2 = query(2*i+1, m+1, r, m+1, qr);
        /*ver q;
        q.min1 = p1.min1 < p2.min1 ? p1.min1 : p2.min1;
        q.max1 = p1.max1 > p2.max1 ? p1.max1 : p2.max1;*/
        return {min(p1.min1,p2.min1) , max(p1.max1,p2.max1)};
    }
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> k ;
    long long i;
    for (i=1; i<=n; ++i)
    {
        cin >> a[i] ;
    }
    make_tree(1, 1, n);
}

void solve()
{
    long long ans = 0, i;
    ver h;
    p[k] = n;
    for (i=1; i<=k; ++i)
    {
        h = query(1, 1, n, p[i-1]+1, p[i]);
        ans += (h.max1-h.min1);
    }
    if (ans > max_ans) max_ans = ans;
}

void v(long long pos, long long last_i)
{
    if (pos == k)
    {
        solve();
        return;
    }
    for (long long i=last_i+2; i<n-1; ++i)
    {
        p[pos] = i;
        v(pos+1, i);
    }
}

int main()
{
    read();
    long long ans = 0;
    if (k == 2)
    {
        v(1,0);
        cout << max_ans << '\n';
    }
    else if (k == 3)
    {
        ver h1 = query(1, 1, n, 1, n/3);
        ver h2 = query(1, 1, n, n/3+1, 2*n/3);
        ver h3 = query(1, 1, n, 2*n/3+1, n);
        ans = (h1.max1-h1.min1) + (h2.max1-h2.min1) + (h3.max1-h3.min1);
        cout << ans << '\n' ;
    }
    else if (k == 4)
    {
        ver h1 = query(1, 1, n, 1, n/4);
        ver h2 = query(1, 1, n, n/4+1, n/2);
        ver h3 = query(1, 1, n, n/2+1, 3*n/4);
        ver h4 = query(1, 1, n, 3*n/4+1, n);
        ans = (h1.max1-h1.min1) + (h2.max1-h2.min1) + (h3.max1-h3.min1) + (h4.max1-h4.min1);
        cout << ans << '\n' ;
    }
    else if (k == 5)
    {
        ver h1 = query(1, 1, n, 1, n/5);
        ver h2 = query(1, 1, n, n/5+1, 2*n/5);
        ver h3 = query(1, 1, n, 2*n/5+1, 3*n/5);
        ver h4 = query(1, 1, n, 3*n/5+1, 4*n/5);
        ver h5 = query(1, 1, n, 4*n/5+1, n);
        ans = (h1.max1-h1.min1) + (h2.max1-h2.min1) + (h3.max1-h3.min1) + (h4.max1-h4.min1) + (h5.max1-h5.min1);
        cout << ans << '\n' ;
    }
    else if (k == 6)
    {
        ver h1 = query(1, 1, n, 1, n/6);
        ver h2 = query(1, 1, n, n/6+1, 2*n/6);
        ver h3 = query(1, 1, n, 2*n/6+1, 3*n/6);
        ver h4 = query(1, 1, n, 3*n/6+1, 4*n/6);
        ver h5 = query(1, 1, n, 4*n/6+1, 5*n/6);
        ver h6 = query(1, 1, n, 5*n/6+1, n);
        ans = (h1.max1-h1.min1) + (h2.max1-h2.min1) + (h3.max1-h3.min1) + (h4.max1-h4.min1) + (h5.max1-h5.min1) + (h6.max1-h6.min1);
        cout << ans << '\n' ;
    }
    else if (k == 7)
    {
        ver h1 = query(1, 1, n, 1, n/7);
        ver h2 = query(1, 1, n, n/7+1, 2*n/7);
        ver h3 = query(1, 1, n, 2*n/7+1, 3*n/7);
        ver h4 = query(1, 1, n, 3*n/7+1, 4*n/7);
        ver h5 = query(1, 1, n, 4*n/7+1, 5*n/7);
        ver h6 = query(1, 1, n, 5*n/7+1, 6*n/7);
        ver h7 = query(1, 1, n, 6*n/7+1, n);
        ans = (h1.max1-h1.min1) + (h2.max1-h2.min1) + (h3.max1-h3.min1) + (h4.max1-h4.min1) + (h5.max1-h5.min1) + (h6.max1-h6.min1) + (h7.max1-h7.min1);
        cout << ans << '\n' ;
    }
    else if (k == 8)
    {
        ver h1 = query(1, 1, n, 1, n/8);
        ver h2 = query(1, 1, n, n/8+1, 2*n/8);
        ver h3 = query(1, 1, n, 2*n/8+1, 3*n/8);
        ver h4 = query(1, 1, n, 3*n/8+1, 4*n/8);
        ver h5 = query(1, 1, n, 4*n/8+1, 5*n/8);
        ver h6 = query(1, 1, n, 5*n/8+1, 6*n/8);
        ver h7 = query(1, 1, n, 6*n/8+1, 7*n/8);
        ver h8 = query(1, 1, n, 7*n/8+1, n);
        ans = (h1.max1-h1.min1) + (h2.max1-h2.min1) + (h3.max1-h3.min1) + (h4.max1-h4.min1) + (h5.max1-h5.min1) + (h6.max1-h6.min1) + (h7.max1-h7.min1) + (h8.max1-h8.min1);
        cout << ans << '\n' ;
    }
    else if (k == 9)
    {
        ver h1 = query(1, 1, n, 1, n/9);
        ver h2 = query(1, 1, n, n/9+1, 2*n/9);
        ver h3 = query(1, 1, n, 2*n/9+1, 3*n/9);
        ver h4 = query(1, 1, n, 3*n/9+1, 4*n/9);
        ver h5 = query(1, 1, n, 4*n/9+1, 5*n/9);
        ver h6 = query(1, 1, n, 5*n/9+1, 6*n/9);
        ver h7 = query(1, 1, n, 6*n/9+1, 7*n/9);
        ver h8 = query(1, 1, n, 7*n/9+1, 8*n/9);
        ver h9 = query(1, 1, n, 8*n/9+1, n);
        ans = (h1.max1-h1.min1) + (h2.max1-h2.min1) + (h3.max1-h3.min1) + (h4.max1-h4.min1) + (h5.max1-h5.min1) + (h6.max1-h6.min1) + (h7.max1-h7.min1) + (h8.max1-h8.min1) + (h9.max1-h9.min1);
        cout << ans << '\n' ;
    }
    return 0;
}