#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;
const int maxn = 1e6 + 10, maxk = 11;
const ll inf = 1e18;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, k;
ll a[maxn], dp[maxn][maxk], f[maxn][maxk], best[maxn][maxk];
/** dp[i][j] - best sum for i elements j cycles*/

void solve()
{
    cin >> n >> k;
    for (int i = 1; i <= n; i ++)
        cin >> a[i];

    for (int i = 0; i <= n; i ++)
        for (int j = 0; j <= k; j ++)
        f[i][j] = -inf, best[i][j] = -inf;

    for (int i = 1; i <= n; i ++)
        f[i][0] = max(f[i - 1][0], - a[i]);

    ll ans = 0;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= k; j ++)
    {

        dp[i][j] = f[i - 1][j - 1] + a[i];
        best[i][j] = max(dp[i][j], best[i - 1][j]);
        f[i][j] = max(f[i - 1][j], best[i - 1][j] - a[i]);
        if (dp[i][j] > ans)
            ans = dp[i][j];
    }

    cout << ans << endl;
}

int main()
{
    speed();
    solve();
	return 0;
}
