#include <bits/stdc++.h>
#include "robo.h"
using namespace std;

const int maxn = 250;
int used[maxn * 2][maxn * 2], srx, sry;

vector < pair < int, int > > v;
void dfs(int x, int y, int fx, int fy, int last, int robo)
{
    if (used[x - 1][y] == -1)
    {
        int man = output(robo, 'U');
        if (man != last)
        {
            used[x - 1][y] = 0;
            dfs(x - 1, y, x, y, man, robo);
        }
        else
        {
            if (man == 1 && robo == 1) /// robot == 1 very important
            {
                int sh = output(2, 'D');
                if (sh != man)
                    output(2, 'U');
                else
                {
                    /// fx !=- 1 && fy != -1
                    int newman;
                    char bk;
                    if (fx < x)
                        newman = output(1, 'U'), bk = 'D';
                    if (fx > x)
                        newman = output(1, 'D'), bk = 'U';
                    if (fy < y)
                        newman = output(1, 'L'), bk = 'R';
                    if (fy > y)
                        newman = output(1, 'R'), bk = 'L';

                    int lamp = 0;
                    sh = output(2, 'D');
                    if (sh != newman)
                        lamp = 1, output(2, 'U');
                    output(1, bk);

                    if (lamp)
                        srx = x - 1, sry = y;
                }
            }
            used[x - 1][y] = 1;
        }
    }

    if (used[x][y - 1] == -1)
    {
        int man = output(robo, 'L');
        if (man != last)
        {
            used[x][y - 1] = 0;
            dfs(x, y - 1, x, y, man, robo);
        }
        else
        {
            if (man == 1 && robo == 1) /// robot == 1 very important
            {
                int sh = output(2, 'R');
                if (sh != man)
                    output(2, 'L');
                else
                {
                    /// fx !=- 1 && fy != -1
                    int newman;
                    char bk;
                    if (fx < x)
                        newman = output(1, 'U'), bk = 'D';
                    if (fx > x)
                        newman = output(1, 'D'), bk = 'U';
                    if (fy < y)
                        newman = output(1, 'L'), bk = 'R';
                    if (fy > y)
                        newman = output(1, 'R'), bk = 'L';

                    int lamp = 0;
                    sh = output(2, 'R');
                    if (sh != newman)
                        lamp = 1, output(2, 'L');
                    output(1, bk);

                    if (lamp)
                        srx = x, sry = y - 1;
                }
            }
            used[x][y - 1] = 1;
        }
    }

    if (used[x][y + 1] == -1)
    {
        int man = output(robo, 'R');
        if (man != last)
        {
            used[x][y + 1] = 0;
            dfs(x, y + 1, x, y, man, robo);
        }
        else
        {
            if (man == 1 && robo == 1) /// robot == 1 very important
            {
                int sh = output(2, 'L');
                if (sh != man)
                    output(2, 'R');
                else
                {
                    /// fx !=- 1 && fy != -1
                    int newman;
                    char bk;
                    if (fx < x)
                        newman = output(1, 'U'), bk = 'D';
                    if (fx > x)
                        newman = output(1, 'D'), bk = 'U';
                    if (fy < y)
                        newman = output(1, 'L'), bk = 'R';
                    if (fy > y)
                        newman = output(1, 'R'), bk = 'L';

                    int lamp = 0;
                    sh = output(2, 'L');
                    if (sh != newman)
                        lamp = 1, output(2, 'R');
                    output(1, bk);

                    if (lamp)
                        srx = x, sry = y + 1;
                }
            }
            used[x][y + 1] = 1;
        }
    }

    if (used[x + 1][y] == -1)
    {
        int man = output(robo, 'D');
        if (man != last)
        {
            used[x + 1][y] = 0;
            dfs(x + 1, y, x, y, man, robo);
        }
        else
        {
            if (man == 1 && robo == 1) /// robot == 1 very important
            {
                int sh = output(2, 'U');
                if (sh != man)
                    output(2, 'D');
                else
                {
                    /// fx !=- 1 && fy != -1
                    int newman;
                    char bk;
                    if (fx < x)
                        newman = output(1, 'U'), bk = 'D';
                    if (fx > x)
                        newman = output(1, 'D'), bk = 'U';
                    if (fy < y)
                        newman = output(1, 'L'), bk = 'R';
                    if (fy > y)
                        newman = output(1, 'R'), bk = 'L';

                    int lamp = 0;
                    sh = output(2, 'U');
                    if (sh != newman)
                        lamp = 1, output(2, 'D');
                    output(1, bk);

                    if (lamp)
                        srx = x + 1, sry = y;
                }
            }
            used[x + 1][y] = 1;
        }
    }

    if (fx == -1)
        return;
    if (fx < x)
        output(robo, 'U');
    if (fx > x)
        output(robo, 'D');
    if (fy < y)
        output(robo, 'L');
    if (fy > y)
        output(robo, 'R');
}

int table[maxn][maxn];
void robo(int r, int c, char store[][201], int dist)
{
    /// IF THE ROBOTS ARE NEXT TO EACH OTHER IT DOESN'T WORK
    for (int i = 0; i < 2 * maxn; i ++)
        for (int j = 0; j < 2 * maxn; j ++)
            used[i][j] = -1;

    used[maxn][maxn] = 0;
    int x1 = maxn, y1 = maxn;

    dfs(x1, y1, -1, -1, dist, 1);

    used[srx][sry] = 0;
    dfs(srx, sry, -1, -1, dist, 2);

    int stx = -1, sty = -1;
    for (int i = 0; i < r; i ++)
        for (int j = 0; j < c; j ++)
    {
        if (store[i][j] == '#')
            continue;
        if (stx != -1)
            continue;
        stx = i;
        sty = j;
    }

    int hstx = -1, hsty = -1;
    for (int i = maxn - r; i < maxn + r; i ++)
        for (int j = maxn - c; j < maxn + c; j ++)
    {

        if (used[i][j] == 1 || used[i][j] == -1)
            continue;
        if (hstx != -1)
        continue;
        hstx = i;
        hsty = j;
    }


    int bx = hstx - stx;
    int by = hsty - sty;

    int corx2 = srx - bx, cory2 = sry - by;
    int corx1 = corx2 - (srx - maxn), cory1 = cory1 - (sry - maxn);

    for (int i = 0; i < r; i ++)
        for (int j = 0; j < c; j ++)
        table[i][j] = used[i + bx][j + by];

    for (int i = 0; i < r; i ++, cout << endl)
        for (int j = 0; j < c; j ++)
        cout << table[i][j] << " ";

    for (int i = 0; i < r; i ++, cout << endl)
        for (int j = 0; j < c; j ++)
        cout << store[i][j] << " ";
    cout << endl;

    for (int i = maxn - 7; i < maxn + 8; i ++, cout << endl)
        for (int j = maxn - 7; j < maxn + 8; j ++)
            cout << setw(2) << used[i][j] << " ";
    cout << srx << " " << sry << endl;
}
